/*

  lock.h: header file to use the lock functions of the psthreads library. 
  Copyright (C) 2002 Thomas Repantis <darkzero@otenet.gr>
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/
 
/*
  lock.h: header file to use the lock functions of the psthreads library. 
*/

#define CHARPADS_PER_CACHE_LINE 32 /* A char is 1 Byte long, therefore 32/1=32. */

/* We use padding to the size of the cache line to avoid false sharing. */

/* This is the descriptor of a synchronization variable. */

typedef struct _psthread_lock {
  char _pad1[CHARPADS_PER_CACHE_LINE];
  volatile char enter;
  char _pad2[CHARPADS_PER_CACHE_LINE - 1];
} psthread_lock_t;

extern void _ps_lock_init(psthread_lock_t *thr_ttas_lock_ptr);
extern void _ps_lock(psthread_lock_t *thr_ttas_lock_ptr);
extern void _ps_unlock(psthread_lock_t *thr_ttas_lock_ptr);

extern int psthread_lock_init(psthread_lock_t *lock_var);
extern int psthread_get_lock(psthread_lock_t *lock_var);
extern int psthread_release_lock(psthread_lock_t *lock_var);

extern void psthread_yield(void);
