#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#ifndef WIN32
#include <sys/mman.h>
#endif
#include "stack.h"

ps_stack_t *_ps_stack_new()
{
  ps_stack_t *ts;

  /* Make a new thread stack object. */
  if ((ts = (ps_stack_t *)calloc(1, sizeof(ps_stack_t))) == NULL)
    return NULL;
  ts->vaddr_size = PS_DEFAULT_STACK_SIZE;
  ts->vaddr = malloc(ts->vaddr_size);
  if (!ts->vaddr) {
    free(ts);
    return NULL;
  }
  ts->stk_size = PS_DEFAULT_STACK_SIZE - _PS_STACK_PAD_SIZE;
  ts->stk_bottom = ts->vaddr;
  ts->stk_top = ts->stk_bottom + PS_DEFAULT_STACK_SIZE;

  /* Allocate thread object and per-thread data off the stack */
#if defined (MD_STACK_GROWS_DOWN)
  ts->sp = ts->stk_top - _PS_STACK_PAD_SIZE;
#elif defined (MD_STACK_GROWS_UP)
  ts->sp = ts->stk_bottom + _PS_STACK_PAD_SIZE;
#else
#error Unknown OS
#endif

  return ts;
}

