#ifndef __PS_STACK_H__
#define __PS_STACK_H__

#include "md.h"

/* This is the descriptor of a user-level thread's stack */

typedef struct _ps_stack {
  char *vaddr;                /* Base of stack's allocated memory */
  int  vaddr_size;            /* Size of stack's allocated memory */
  int  stk_size;              /* Size of usable portion of the stack */
  char *stk_bottom;           /* Lowest address of stack's usable portion */
  char *stk_top;              /* Highest address of stack's usable portion */
  void *sp;                   /* Stack pointer from C's point of view */
} ps_stack_t;

/* This is the default size of a user-level thread's stack. Feel free to change it */
#define PS_DEFAULT_STACK_SIZE (16*1024)

/*
 * Number of bytes reserved under the stack "bottom"
 */
#define _PS_STACK_PAD_SIZE MD_STACK_PAD_SIZE


/*****************************************
 * Forward declarations
 */
ps_stack_t *_ps_stack_new(void);

#endif /* __PS_STACK_H__ */

